/**
 * Created by Administrator on 2017/7/3.
 */
var gameID = "";        // 登录验证需要用到的 gameID
var channelID = "";     // 登录验证需要用到的 channelID
var appID = "";         // 登录验证需要用到的 appID
var uid = '';           // 登录验证需要用到的 uid
var sid = '';           // 登录验证需要用到的 sid

var user_id = '';       // 服务器 登录验证后 返回的 uid
var loginRspData = '';  // 登录验证返回的 数据 里的 data 字段 ( 需回传给 SDK )

function SDK_Type() {
    this.INIT = 'init';
    this.LOGIN = 'login';
    this.GET_SDK_INFO = 'get_sdk_info';
    this.LOGIN_RSP = 'login_rsp';
    this.LOGOUT = 'logout';
    this.USER_INFO = "user_info"
    this.SWITCH_ACCOUNT = 'switch_account';
    this.PAY = 'pay';
}

/**
 * 调用 android SDK 初始化 接口
 */
function onInit() {
    android.onInit(1, "onCallback");
}

/**
 * 调用 android SDK 登录 接口
 */
function onLogin() {
    android.onLogin();
}

/**
 * 调用 android SDK 获取 GameID , ChannelID , AppID 接口
 * 当前 此处的 3个参数 在 SDK服务器 登录验证的时候 需要用到 请务必获取再传到服务器上进行 登录验证
 */
function getSDKConfigInfo() {
    gameID = android.getGameID();
    channelID = android.getChannelID();
    appID = android.getAppID();
    alert("GameID : " + gameID + "\nChannelID : " + channelID + "\nAppID : " + appID);
}

/**
 * 调用 android SDK 登录验证 接口
 * ( 此处只提供给Demo 使用 , 正确的做法请查看服务器端文档 请求 获取用户信息接口 )
 */
function getLoginUserInfo() {
    gameID = android.getGameID();
    channelID = android.getChannelID();
    appID = android.getAppID();
    android.getLoginUserInfo(uid, sid, gameID, channelID, appID);
}

/**
 * 调用 android SDK 回传登录验证数据 接口
 * ( 注意 必须要回传 登录验证后的数据 否则会导致 SDK 某些功能不能使用 )
 */
function onLoginRsp() {
    /**
     * 服务器 请求 鹰魂 二次验证后 返回的 格式 大致如下
     * 需要把 content 内的 data 取出来 原样回传到 SDK
     {
        "ret": 0,
        "msg": "成功",
        "content": {
            ↓↓↓↓↓ 只回传 这一块 json ↓↓↓↓↓
            "data": {
                "gameId": "xxxxx",
                "channelId": "xxxxx",
                "appId": "xxxxx",
                "userId": "xxxxx",
                "accessToken": "xxxxx",
                "sdkData": {
                    "channelUid": "xxxxx"
                }
            }
            ↑↑↑↑↑ 只回传 这一块 json ↑↑↑↑↑
            ,"cData": {
            }
        }
     }
     */
    android.onLoginRsp(JSON.stringify(loginRspData));
}

/**
 * 调用 android SDK 注销账号 接口
 */
function onLogout() {
    android.onLogout();
}

/**
 * 调用 android SDK 上传创建角色 接口
 */
function onUploadCreateRole () {
    // 创建 角色信息 JSON
    android.onUploadCreateRole(JSON.stringify(getUserInfo("")));
}

/**
 * 调用 android SDK 上传角色信息 接口
 */
function onLoginRoleInfo() {
    // 角色信息 JSON
    android.onLoginRoleInfo(JSON.stringify(getUserInfo("")));
}

/**
 * 调用 android SDK 上传角色升级 接口
 */
function onUpdateRoleInfo() {
    //  角色信息 JSON
    android.onUpdateRoleInfo(JSON.stringify(getUserInfo("")));
}

/**
 * 调用 android SDK 上传自定义事件 接口
 */
function onReportTaskEvent() {
    //  角色信息 JSON
    android.onReportTaskEvent(JSON.stringify(getUserInfo("测试事件")));
}
/**
 * 调用 android SDK 上传购买物品 接口
 */
function onBuyItem() {
    // 角色信息 JSON , 商品信息 JSON
    android.onBuyItem(JSON.stringify(getUserInfo("")), JSON.stringify(getProductInfo()));
}

/**
 * 模拟生成 角色信息
 */
function getUserInfo(task) {
    var user_info = {
        "task"        : task,             // 事件名称
        "uid"         : "test_uid",       // 用户Uid
        "role_id"     : "test_role_id",   // 角色 ID
        "role_name"   : "test_role_name", // 角色名称
        "role_level"  : 1,                // 角色等级
        "vip_level"   : 1,                // VIP等级
        "server_id"   : 1,                // 服务器ID
        "server_name" : "S01",            // 服务器名称
        "remain_coin" : 1000,             // 当前角色<非绑定>元宝(钻石) 余额总数
        "party"       : "公会",           // 公会名称
        "role_ctime"  : 1504179289        // 角色创建时间 若无 填 : -1 ( 传递时间戳 ,精确到秒 )
    };
    return user_info;
}

/**
 * 模拟生成 商品信息
 */
function getProductInfo() {
    var product_info = {
        "fromPay"     : true,                // 获得 或 消耗的元宝 是否由 充值获得
        "isGain"      : true,                // 是否为 获得元宝 事件
        "coin"        : 100,                 // 总共消耗的游戏币
        "remain_coin" : 900,                 // 当前余额 (购买过后)
        "item_count"  : 1,                   // 购买物品个数
        "item_name"   : "药瓶",              // 物品名称
        "item_desc"   : "恢复1000点生命值",  // 物品描述
        "action_name" : "购买道具"           // 行为名称 ( 购买物品 , 升级装备 , 钻石抽奖 )
    };
    return product_info;
}

/**
 * 调用 android SDK 支付 接口
 */
function onPay() {
    // 创建 订单信息 JSON
    var order_info = {
        "cp_order_id"   : (new Date()).valueOf(),   // CP 订单号
        "role_id"       : "test_role_id",           // 角色 ID
        "role_name"     : "test_role_name",         // 角色名称
        "role_level"    : 100,                      // 角色等级
        "vip_level"     : 1,                        // VIP 等级
        "server_id"     : 1,                        // 服务器 ID
        "server_name"   : "s01",                    // 服务器名称
        "amount"        : 1,                      // 金额 ( 单位为 : 分 )
        "product_count" : 60,                       // 购买数量 ( 如:充值60元宝 则填 60 )
        "product_name"  : "60元宝",                  // 商品名称
        "product_type"  : "元宝",                    // 商品类型 ( 如 : 元宝 )
        "product_id"    : 1,                        // 商品ID
        "product_desc"  : "购买60元宝",              // 商品描述
        "rate"          : 10,                       // 兑换比率 (默认填: 10)
        "notify_url"    : "http://bingniao.data.wangzhe.zsgames.cn/agent/bn_yh/recharge.php", // 支付回调地址
    };
    android.onPay(JSON.stringify(order_info));
}

/**
 * 调用 android SDK 跳转游戏链接 接口
 */
function onOpneGameUrl() {
    android.onOpenGameUrl();
}

/**
 * 接收回调的 函数
 * @param data 返回的 json 数据
 */
function onCallback(callback_type, callback_data) {
    var type = new SDK_Type();
    var data = eval('(' + callback_data + ')');
    var ret = data["ret"];  // 状态码
    var msg = data["msg"];  // 返回信息

    switch(callback_type) {
        /* 初始化 回调 */
        case type.INIT:
            if(ret == 1) {
                alert("初始化成功");
            }else {
                alert("初始化失败");
            }
            break;

        /* 登录 回调 */
        case type.LOGIN:
            if(ret == 1) {
                // 用于服务器 登录验证用的 sid 和 uid (可能为空)
                // 注意此处的 uid 并非 最终账号唯一标识
                // 账号uid 要以SDK服务器 登录验证成功 后返回的为准
                uid = data["uid"];
                extra = data["extra"];
                sid = data["sid"];
                alert("登录成功 \n sid : " + sid + "\n uid : " + uid + "\n extra : " + extra);
            }else if(ret == 2) {
                alert("登录取消");
            }else {
                alert("登录失败");
            }
            break;

        /* 服务器登录验证 回传数据接口 回调 */
        case type.LOGIN_RSP:
            if(ret == 1) {
                alert("回传登录验证数据 成功 , 进入游戏");
            }else {
                alert("回传登录验证数据 失败 , 引导玩家进行重新登录")
            }
            break;

        /* 切换账号成功 回调 */
        case type.SWITCH_ACCOUNT:
            // 用于服务器 登录验证用的 sid 和 uid (可能为空)
            // 注意此处的 uid 并非 最终账号唯一标识
            // 账号uid 要以SDK服务器 登录验证成功 后返回的为准
            // 注意 接收到切换账号后 需重新进行登录验证 并 返回到游戏选区界面
            uid = data["uid"];
            extra = data["extra"];
            sid = data["sid"];
            alert("切换账号登录成功 \n sid : " + sid + "\n uid : " + uid + "\n extra : " + extra);
            break;

        /* 注销成功 回调 */
        case type.LOGOUT:
            // 接收到注销成功后 需要返回到游戏登录界面
            alert("注销账号成功");
            break;

        /* 登录验证回调 */ // 注意 该接口 只提供给 Demo 使用 游戏请自行在服务器 进行登录验证操作
        case type.USER_INFO:
            if(ret == 1) {
                user_id = data["user_id"];
                loginRspData = data["loginRspData"];
                alert("登录验证成功 \n user_id : " + user_id + "\n loginRspData : " + JSON.stringify(loginRspData));
            }else {
                alert("登录验证失败");
            }
            break;

        /* 支付 回调 */
        case type.PAY:
            if(ret == 1) {
                // 支付成功
            }else if(ret == 2) {
                // 支付取消
            }else {
                // 支付失败
            }
            break;

        default:
    }
}